///////////////////////////////////////////////////////////////////////////////
//
//      ##  ######
//       ######  ###
//  ## ###############        Shark 3D Engine (www.shark3d.com)
//   ########## # # #
//    ########                Copyright (c) 1996-2006 Spinor GmbH.
//   ######### # # #          All rights reserved.
//  ##   ##########
//      ##
//
///////////////////////////////////////////////////////////////////////////////

//@cpp

#include "gtp_shader_module.h"
#include "gtp_shader_envmap.h"
#include "gtp_shader_focusedprojmat.h"
#include "eng_shader_special_worldmat.h"
#include "gtp_shader_mainenum.h"
#include "gtp_shader_createtex.h"
#include "gtp_shader_cubetexfilter.h"
#include "gtp_shader_causticcube.h"
#include "../../util/eng_util_shaderutil.h"
#include "../../../general/general_def.h"

///////////////////////////////////////////////////////////////////////////////
/*@{ 

@declare{mod.mod}{eng_shader_special}{}

Special shaders.
@p

@}*/
///////////////////////////////////////////////////////////////////////////////

s3d_CCompObjPtr gtp_ShaderModuleSuppl::SupplObj(
                s3d_CUtilMsgHandler *MsgHandler, s3d_CUtilStr_cr Info,
                s3d_CUtilStr_cr Ident, s3d_CUtilStr_cr Version)
{
    if(!s3d_CompSupplCheckVersion(
            MsgHandler, Info, Ident, S3D_GENERAL_INTEROP_INTERF, Version))
        return 0;


    if(Ident == "envmap")
        return S3D_SYS_NEW gtp_Shader_EnvMap();
	if(Ident == "createtex")
	    return S3D_SYS_NEW gtp_ShaderCreateTex();
	if(Ident == "worldmat")
	    return S3D_SYS_NEW s3d_CEngShaderSpecialWorldMat();
	if(Ident == "cubetexfilter")
		return S3D_SYS_NEW gtp_Shader_CubeTexFilter();
	if(Ident == "mainenum")
		return S3D_SYS_NEW gtp_Shader_MainEnum();
	if(Ident == "focusedprojmat")
		return S3D_SYS_NEW gtp_Shader_FocusedProjMat();
	if(Ident == "causticcube")
		return S3D_SYS_NEW gtp_Shader_CausticCube();
   
    s3d_CompSupplUnknownIdent(MsgHandler, Info, Ident);
    return 0;
}

///////////////////////////////////////////////////////////////////////////////

s3d_CUtilStr gtp_ShaderModuleCover::GetName() const
{
    return "gtp_shader";
}

s3d_CUtilStr gtp_ShaderModuleCover::GetAbout() const
{
    return S3D_GENERAL_IDENT_EXE;
}

s3d_CCompSupplPtr gtp_ShaderModuleCover::CreateSuppl(
                s3d_CUtilMsgHandler *MsgHandler, s3d_CUtilStr_cr Info,
                const s3d_CUtilSnkChunk *Param) const
{
    return S3D_SYS_NEW gtp_ShaderModuleSuppl;
}

///////////////////////////////////////////////////////////////////////////////

